@echo off
echo.
if exist geodata\obdata.dat goto gameok
echo Game not found in this directory
goto finis

:gameok
if not exist game_1  md game_1
if not exist game_2  md game_2
if not exist game_3  md game_3
if not exist game_4  md game_4
if not exist game_5  md game_5
if not exist game_6  md game_6
if not exist game_7  md game_7
if not exist game_8  md game_8
if not exist game_9  md game_9
if not exist game_10 md game_10
if not exist missdat md missdat
if not exist missdat\saveinfo.dat echo dummy >missdat\saveinfo.dat
if not exist missdat\mission2.dat echo dummy >missdat\mission2.dat

xcomutil QueryInfo CheckSetup >nul
if errorlevel 1 if exist xcomutil.rms erase xcomutil.rms

if not exist ufoexe\geoscape.exe goto xcomce

if not exist ufoexe\geoscape.xcu  copy ufoexe\geoscape.exe  ufoexe\geoscape.xcu  >nul
if not exist ufo2exe\tactical.xcu copy ufo2exe\tactical.exe ufo2exe\tactical.xcu >nul
goto begin

:xcomce
if not exist tftdwin.exe goto notfwin
erase tftdwin.exe
if exist xcom4win.xcf erase xcom4win.xcf
:notfwin
if not exist xcomutil.doc goto noldstf
if exist xcom4win.xcf erase xcom4win.xcf
erase xcomutil.doc
:noldstf
if not exist xcom4win.xcf if exist tftd4win.xcf erase tftd4win.xcf

if exist xcom4win.xcf goto begin

rem Setup XCOM/TFTD for Windows

if exist "terror from the deep.exe" goto tftdwin
if exist terror.exe                 goto tftdwin

if exist ufo.exe           copy ufo.exe           geoscape.exe >nul
if exist "ufo defense.exe" copy "ufo defense.exe" geoscape.exe >nul
if exist geoscape.exe      copy geoscape.exe      tactical.exe >nul
if not exist tactical.exe  goto errspl
sdump geoscape.exe patch:SplitGeo XcomUtil.cfg >nul
sdump tactical.exe patch:SplitTac XcomUtil.cfg >nul

echo When using XCOMUTIL with XCOM for Windows, it is best to create a

:cmnxcw
echo shortcut.  If you are having video problems, you should enable f0dder's
echo bugfix loader.  Please follow these instructions now, since they will
echo not be repeated unless you delete XCOM4WIN.XCF.

if exist patch.dll erase patch.dll
echo.
echo Do you want to enable f0dder's loader? (N)
sdump * getresp yYnN n
if errorlevel 3 goto nof0ldr
if not exist tftd4win.xcf copy patchxc1.dll patch.dll >nul
if     exist tftd4win.xcf copy patchxc2.dll patch.dll >nul
:nof0ldr

echo.
echo Right-click on any portion of the desktop background, then select New, then
echo Shortcut, then Browse.  Go to the directory in which the game is installed
echo and select RunXcomW.bat.  After you select the Next button twice, you will
echo see a selection of icons.  Since this is a batch file, you get to choose
echo the icon you want.  I recommend the one that looks like a satellite dish.
echo Finally, select Finish.  You MUST use this shortcut to start the game.
echo If you are using WinNT or Win2K, you will not be given the opportunity to
echo choose your icon.

echo XCOM for Windows >xcom4win.xcf

echo.
pause
goto begin

:errspl
echo.
echo XCOMUTIL was unable to split the Windows executable and is aborting
goto finis

:tftdwin
if exist "terror from the deep.exe" copy "terror from the deep.exe" geoscape.exe >nul
if exist terror.exe                 copy terror.exe                 geoscape.exe >nul
if exist geoscape.exe               copy geoscape.exe               tactical.exe >nul
if not exist tactical.exe           goto errspl
sdump geoscape.exe patch:SplitGeoT XcomUtil.cfg >nul
sdump tactical.exe patch:SplitTacT XcomUtil.cfg >nul

echo When using XCOMUTIL with TFTD for Windows, it is best to create a
echo TFTD for Windows >tftd4win.xcf
goto cmnxcw

rem Begin standard installation

:begin
xcomutil ufoexe >nul
if errorlevel 1 if exist mapfixed.xcf erase mapfixed.xcf

if exist renamall.xcf erase renamall.xcf
if exist renamrnk.xcf erase renamrnk.xcf
if exist renamkil.xcf erase renamkil.xcf
if exist autosort.xcf erase autosort.xcf
if exist autoeqip.xcf erase autoeqip.xcf
if exist autoscrn.xcf erase autoscrn.xcf
if exist daylight.xcf erase daylight.xcf
if exist darkness.xcf erase darkness.xcf
if exist mpprompt.xcf erase mpprompt.xcf
if exist mprandom.xcf erase mprandom.xcf
if exist rndshape.xcf erase rndshape.xcf
if exist saverand.xcf erase saverand.xcf
if exist chgufo1a.xcf erase chgufo1a.xcf
if exist chgufo02.xcf erase chgufo02.xcf
if exist cmbtmsgs.xcf erase cmbtmsgs.xcf
if exist rndplace.xcf erase rndplace.xcf

if exist runxcom.bat erase runxcom.bat
copy runxcomw.bat runxcom.bat >nul

if exist terror.com  goto tftd
if exist xcom4win.xcf if exist tftd4win.xcf goto tftd

echo XCOMUTIL Setup for XCOM/UFO
if not exist maps\ufo1a.xcu   copy maps\ufo1a.map   maps\ufo1a.xcu   >nul
if not exist routes\ufo1a.xcu copy routes\ufo1a.rmp routes\ufo1a.xcu >nul
if not exist terrain\ufo1.xcu copy terrain\ufo1.mcd terrain\ufo1.xcu >nul

if exist shipadon.xcf goto xcomadon

if exist maps\plane.xcu    copy maps\plane.xcu    maps\plane.map    >nul
if exist maps\lightnin.xcu copy maps\lightnin.xcu maps\lightnin.map >nul
if exist maps\avenger.xcu  copy maps\avenger.xcu  maps\avenger.map  >nul
if exist maps\noship.map   copy maps\noship.map   maps\ufo1a.map    >nul
if exist maps\ufo_110.xcu  copy maps\ufo_110.xcu  maps\ufo_110.map  >nul
if exist maps\ufo_120.xcu  copy maps\ufo_120.xcu  maps\ufo_120.map  >nul
if exist maps\ufo_130.xcu  copy maps\ufo_130.xcu  maps\ufo_130.map  >nul
if exist maps\ufo_140.xcu  copy maps\ufo_140.xcu  maps\ufo_140.map  >nul
if exist maps\ufo_150.xcu  copy maps\ufo_150.xcu  maps\ufo_150.map  >nul
if exist maps\ufo_160.xcu  copy maps\ufo_160.xcu  maps\ufo_160.map  >nul
if exist maps\ufo_170.xcu  copy maps\ufo_170.xcu  maps\ufo_170.map  >nul
if exist routes\plane.xcu    copy routes\plane.xcu    routes\plane.rmp    >nul
if exist routes\lightnin.xcu copy routes\lightnin.xcu routes\lightnin.rmp >nul
if exist routes\avenger.xcu  copy routes\avenger.xcu  routes\avenger.rmp  >nul
if exist routes\noship.rmp   copy routes\noship.rmp   routes\ufo1a.rmp    >nul
if exist routes\ufo_110.xcu  copy routes\ufo_110.xcu  routes\ufo_110.rmp  >nul
if exist routes\ufo_120.xcu  copy routes\ufo_120.xcu  routes\ufo_120.rmp  >nul
if exist routes\ufo_130.xcu  copy routes\ufo_130.xcu  routes\ufo_130.rmp  >nul
if exist routes\ufo_140.xcu  copy routes\ufo_140.xcu  routes\ufo_140.rmp  >nul
if exist routes\ufo_150.xcu  copy routes\ufo_150.xcu  routes\ufo_150.rmp  >nul
if exist routes\ufo_160.xcu  copy routes\ufo_160.xcu  routes\ufo_160.rmp  >nul
if exist routes\ufo_170.xcu  copy routes\ufo_170.xcu  routes\ufo_170.rmp  >nul
if exist terrain\blanks.mcd  copy terrain\blanks.mcd  terrain\ufo1.mcd    >nul

:xcomadon

if not exist maps\plane.xcu    copy maps\plane.map    maps\plane.xcu    >nul
if not exist maps\lightnin.xcu copy maps\lightnin.map maps\lightnin.xcu >nul
if not exist maps\avenger.xcu  copy maps\avenger.map  maps\avenger.xcu  >nul
if not exist maps\ufo_110.xcu  copy maps\ufo_110.map  maps\ufo_110.xcu  >nul
if not exist maps\ufo_120.xcu  copy maps\ufo_120.map  maps\ufo_120.xcu  >nul
if not exist maps\ufo_130.xcu  copy maps\ufo_130.map  maps\ufo_130.xcu  >nul
if not exist maps\ufo_140.xcu  copy maps\ufo_140.map  maps\ufo_140.xcu  >nul
if not exist maps\ufo_150.xcu  copy maps\ufo_150.map  maps\ufo_150.xcu  >nul
if not exist maps\ufo_160.xcu  copy maps\ufo_160.map  maps\ufo_160.xcu  >nul
if not exist maps\ufo_170.xcu  copy maps\ufo_170.map  maps\ufo_170.xcu  >nul
if not exist routes\plane.xcu    copy routes\plane.rmp    routes\plane.xcu    >nul
if not exist routes\lightnin.xcu copy routes\lightnin.rmp routes\lightnin.xcu >nul
if not exist routes\avenger.xcu  copy routes\avenger.rmp  routes\avenger.xcu  >nul
if not exist routes\ufo_110.xcu  copy routes\ufo_110.rmp  routes\ufo_110.xcu  >nul
if not exist routes\ufo_120.xcu  copy routes\ufo_120.rmp  routes\ufo_120.xcu  >nul
if not exist routes\ufo_130.xcu  copy routes\ufo_130.rmp  routes\ufo_130.xcu  >nul
if not exist routes\ufo_140.xcu  copy routes\ufo_140.rmp  routes\ufo_140.xcu  >nul
if not exist routes\ufo_150.xcu  copy routes\ufo_150.rmp  routes\ufo_150.xcu  >nul
if not exist routes\ufo_160.xcu  copy routes\ufo_160.rmp  routes\ufo_160.xcu  >nul
if not exist routes\ufo_170.xcu  copy routes\ufo_170.rmp  routes\ufo_170.xcu  >nul

if not exist maps\xbase_01.xcu xcopy maps\xbase_*.map maps\xbase_*.xcu >nul
if not exist maps\ubase_01.xcu xcopy maps\ubase_*.map maps\ubase_*.xcu >nul

if not exist routes\xbase_21.rmp copy routes\urban03.rmp  routes\xbase_21.rmp >nul
if not exist routes\ubase_16.rmp copy routes\urban03.rmp  routes\ubase_16.rmp >nul

if exist maps\interc.map goto intercOK
copy interc.map          maps\interc.map   >nul
copy interc.map          maps\interc.xcu   >nul
copy routes\plane.rmp    routes\interc.rmp >nul
copy routes\plane.rmp    routes\interc.xcu >nul
copy terrain\plane.*     terrain\interc.*  >nul
:intercOK
if exist maps\fires.map goto firesOK
copy fires.map           maps\fires.map   >nul
copy fires.map           maps\fires.xcu   >nul
copy routes\lightnin.rmp routes\fires.rmp >nul
copy routes\lightnin.rmp routes\fires.xcu >nul
copy terrain\lightnin.*  terrain\fires.*  >nul
:firesOK
erase maps\avenger.map
copy  avenger.map maps >nul
if not exist xcomutil.rnd copy xcomutil.rnx xcomutil.rnd >nul
if not exist xcomutil.rms copy xcomutil.rmx xcomutil.rms >nul

if .%1.==.. goto common
if not exist %1\routes\atlan00.rmp goto common
echo.
echo Copying TFTD files for Hybrid XCOM from %1

if not exist terrain\planebak.mcd copy terrain\plane.mcd terrain\planebak.mcd >nul
if not exist terrain\planebak.tab copy terrain\plane.tab terrain\planebak.tab >nul
if not exist terrain\planebak.pck copy terrain\plane.pck terrain\planebak.pck >nul

copy %1\maps\*.*      maps          >nul
copy %1\routes\*.*    routes        >nul
copy %1\terrain\*.*   terrain       >nul
copy %1\terrain\*.pck terrain\*.xcu >nul

if not exist terrain\planes.mcd copy terrain\plane.mcd terrain\planes.mcd >nul
if not exist terrain\planes.tab copy terrain\plane.tab terrain\planes.tab >nul
if not exist terrain\planes.pck copy terrain\plane.pck terrain\planes.pck >nul
if not exist terrain\planes.xcu copy terrain\plane.pck terrain\planes.xcu >nul
copy terrain\planebak.* terrain\plane.* >nul

if not exist %1\routes\seabed00.rmp goto minihyb

if not exist maps\grunge01.xcu xcopy maps\grunge*.map maps\grunge*.xcu >nul
if not exist maps\a_base01.xcu xcopy maps\a_base*.map maps\a_base*.xcu >nul
if not exist maps\alship01.xcu xcopy maps\alship*.map maps\alship*.xcu >nul
if not exist maps\level01.xcu  xcopy maps\level*.map  maps\level*.xcu  >nul
if not exist maps\crypt01.xcu  xcopy maps\crypt*.map  maps\crypt*.xcu  >nul

if not exist routes\grunge17.rmp copy routes\seabed00.rmp routes\grunge17.rmp >nul
if not exist routes\a_base16.rmp copy routes\seabed00.rmp routes\a_base16.rmp >nul
if not exist routes\alship18.rmp copy routes\seabed00.rmp routes\alship18.rmp >nul
if not exist routes\level00.rmp  copy routes\seabed00.rmp routes\level00.rmp  >nul
if not exist routes\crypt00.rmp  copy routes\seabed00.rmp routes\crypt00.rmp  >nul

:minihyb
echo %1 >hybrdpth.xcf

goto common

:tftd
echo XCOMUTIL Setup for TFTD

if not exist maps\ufo01.xcu   echo Fixing Survey Ship and Escort Mixup
if not exist maps\ufo01.xcu   copy maps\ufo02.map   maps\ufo01.xcu   >nul
if not exist maps\ufo02.xcu   copy maps\ufo01.map   maps\ufo02.xcu   >nul
if not exist routes\ufo01.xcu copy routes\ufo02.rmp routes\ufo01.xcu >nul
if not exist routes\ufo02.xcu copy routes\ufo01.rmp routes\ufo02.xcu >nul

if not exist terrain\planes.mcd copy terrain\plane.mcd terrain\planes.mcd >nul
if not exist terrain\planes.tab copy terrain\plane.tab terrain\planes.tab >nul
if not exist terrain\planes.pck copy terrain\plane.pck terrain\planes.pck >nul

if exist shipadon.xcf goto tftdadon

if exist maps\triton.xcu  copy maps\triton.xcu  maps\triton.map  >nul
if exist maps\hammer.xcu  copy maps\hammer.xcu  maps\hammer.map  >nul
if exist maps\leviath.xcu copy maps\leviath.xcu maps\leviath.map >nul
if exist maps\noship.map  copy maps\noship.map  maps\ufo01.map   >nul
if exist maps\ufo02.xcu   copy maps\ufo02.xcu   maps\ufo02.map   >nul
if exist maps\ufo03.xcu   copy maps\ufo03.xcu   maps\ufo03.map   >nul
if exist maps\ufo04.xcu   copy maps\ufo04.xcu   maps\ufo04.map   >nul
if exist maps\ufo05.xcu   copy maps\ufo05.xcu   maps\ufo05.map   >nul
if exist maps\ufo06.xcu   copy maps\ufo06.xcu   maps\ufo06.map   >nul
if exist maps\ufo07.xcu   copy maps\ufo07.xcu   maps\ufo07.map   >nul
if exist maps\ufo08.xcu   copy maps\ufo08.xcu   maps\ufo08.map   >nul
if exist routes\triton.xcu  copy routes\triton.xcu  routes\triton.rmp  >nul
if exist routes\hammer.xcu  copy routes\hammer.xcu  routes\hammer.rmp  >nul
if exist routes\leviath.xcu copy routes\leviath.xcu routes\leviath.rmp >nul
if exist routes\noship.rmp  copy routes\noship.rmp  routes\ufo01.rmp   >nul
if exist routes\ufo02.xcu   copy routes\ufo02.xcu   routes\ufo02.rmp   >nul
if exist routes\ufo03.xcu   copy routes\ufo03.xcu   routes\ufo03.rmp   >nul
if exist routes\ufo04.xcu   copy routes\ufo04.xcu   routes\ufo04.rmp   >nul
if exist routes\ufo05.xcu   copy routes\ufo05.xcu   routes\ufo05.rmp   >nul
if exist routes\ufo06.xcu   copy routes\ufo06.xcu   routes\ufo06.rmp   >nul
if exist routes\ufo07.xcu   copy routes\ufo07.xcu   routes\ufo07.rmp   >nul
if exist routes\ufo08.xcu   copy routes\ufo08.xcu   routes\ufo08.rmp   >nul

:tftdadon

if not exist maps\triton.xcu  copy maps\triton.map  maps\triton.xcu  >nul
if not exist maps\hammer.xcu  copy maps\hammer.map  maps\hammer.xcu  >nul
if not exist maps\leviath.xcu copy maps\leviath.map maps\leviath.xcu >nul
if not exist maps\ufo03.xcu   copy maps\ufo03.map   maps\ufo03.xcu   >nul
if not exist maps\ufo04.xcu   copy maps\ufo04.map   maps\ufo04.xcu   >nul
if not exist maps\ufo05.xcu   copy maps\ufo05.map   maps\ufo05.xcu   >nul
if not exist maps\ufo06.xcu   copy maps\ufo06.map   maps\ufo06.xcu   >nul
if not exist maps\ufo07.xcu   copy maps\ufo07.map   maps\ufo07.xcu   >nul
if not exist maps\ufo08.xcu   copy maps\ufo08.map   maps\ufo08.xcu   >nul
if not exist routes\triton.xcu  copy routes\triton.rmp  routes\triton.xcu  >nul
if not exist routes\hammer.xcu  copy routes\hammer.rmp  routes\hammer.xcu  >nul
if not exist routes\leviath.xcu copy routes\leviath.rmp routes\leviath.xcu >nul
if not exist routes\ufo03.xcu   copy routes\ufo03.rmp   routes\ufo03.xcu   >nul
if not exist routes\ufo04.xcu   copy routes\ufo04.rmp   routes\ufo04.xcu   >nul
if not exist routes\ufo05.xcu   copy routes\ufo05.rmp   routes\ufo05.xcu   >nul
if not exist routes\ufo06.xcu   copy routes\ufo06.rmp   routes\ufo06.xcu   >nul
if not exist routes\ufo07.xcu   copy routes\ufo07.rmp   routes\ufo07.xcu   >nul
if not exist routes\ufo08.xcu   copy routes\ufo08.rmp   routes\ufo08.xcu   >nul

if not exist maps\grunge01.xcu xcopy maps\grunge*.map maps\grunge*.xcu >nul
if not exist maps\a_base01.xcu xcopy maps\a_base*.map maps\a_base*.xcu >nul
if not exist maps\alship01.xcu xcopy maps\alship*.map maps\alship*.xcu >nul
if not exist maps\level01.xcu  xcopy maps\level*.map  maps\level*.xcu  >nul
if not exist maps\crypt01.xcu  xcopy maps\crypt*.map  maps\crypt*.xcu  >nul

if not exist routes\grunge17.rmp copy routes\seabed00.rmp routes\grunge17.rmp >nul
if not exist routes\a_base16.rmp copy routes\seabed00.rmp routes\a_base16.rmp >nul
if not exist routes\alship18.rmp copy routes\seabed00.rmp routes\alship18.rmp >nul
if not exist routes\level00.rmp  copy routes\seabed00.rmp routes\level00.rmp  >nul
if not exist routes\crypt00.rmp  copy routes\seabed00.rmp routes\crypt00.rmp  >nul

if exist maps\barracud.map goto barracudOK
copy barracud.map      maps\barracud.map  >nul
copy barracud.map      maps\barracud.xcu  >nul
copy routes\triton.*   routes\barracud.*  >nul
copy terrain\triton.*  terrain\barracud.* >nul
:barracudOK
if exist maps\manta.map goto mantaOK
copy manta.map         maps\manta.map  >nul
copy manta.map         maps\manta.xcu  >nul
copy routes\hammer.*   routes\manta.*  >nul
copy terrain\hammer.*  terrain\manta.* >nul
:mantaOK
erase maps\hammer.map
copy  hammer.map maps >nul
if not exist xcomutil.rnd copy xcomutil.rnt xcomutil.rnd >nul
if not exist xcomutil.rms copy xcomutil.rmt xcomutil.rms >nul

if .%1.==.. goto common
if not exist %1\routes\urban03.rmp goto common
echo.
echo Copying XCOM files for Hybrid TFTD from %1

copy %1\maps\*.*      maps          >nul
copy %1\routes\*.*    routes        >nul
copy %1\terrain\*.*   terrain       >nul
copy %1\terrain\*.pck terrain\*.xcu >nul

if not exist terrain\barn.xcu     copy terrain\barn.pck     terrain\barn.xcu     >nul
if not exist terrain\brain.xcu    copy terrain\brain.pck    terrain\brain.xcu    >nul
if not exist terrain\cultivat.xcu copy terrain\cultivat.pck terrain\cultivat.xcu >nul
if not exist terrain\desert.xcu   copy terrain\desert.pck   terrain\desert.xcu   >nul
if not exist terrain\forest.xcu   copy terrain\forest.pck   terrain\forest.xcu   >nul
if not exist terrain\frniture.xcu copy terrain\frniture.pck terrain\frniture.xcu >nul
if not exist terrain\jungle.xcu   copy terrain\jungle.pck   terrain\jungle.xcu   >nul
if not exist terrain\mars.xcu     copy terrain\mars.pck     terrain\mars.xcu     >nul
if not exist terrain\mount.xcu    copy terrain\mount.pck    terrain\mount.xcu    >nul
if not exist terrain\polar.xcu    copy terrain\polar.pck    terrain\polar.xcu    >nul
if not exist terrain\roads.xcu    copy terrain\roads.pck    terrain\roads.xcu    >nul
if not exist terrain\u_base.xcu   copy terrain\u_base.pck   terrain\u_base.xcu   >nul
if not exist terrain\u_pods.xcu   copy terrain\u_pods.pck   terrain\u_pods.xcu   >nul
if not exist terrain\u_wall02.xcu copy terrain\u_wall02.pck terrain\u_wall02.xcu >nul
if not exist terrain\urban.xcu    copy terrain\urban.pck    terrain\urban.xcu    >nul
if not exist terrain\urbits.xcu   copy terrain\urbits.pck   terrain\urbits.xcu   >nul
if not exist terrain\xbase1.xcu   copy terrain\xbase1.pck   terrain\xbase1.xcu   >nul
if not exist terrain\xbase2.xcu   copy terrain\xbase2.pck   terrain\xbase2.xcu   >nul

if not exist maps\xbase_01.xcu xcopy maps\xbase_*.map maps\xbase_*.xcu >nul
if not exist maps\ubase_01.xcu xcopy maps\ubase_*.map maps\ubase_*.xcu >nul

if not exist routes\xbase_21.rmp copy routes\urban03.rmp  routes\xbase_21.rmp >nul
if not exist routes\ubase_16.rmp copy routes\urban03.rmp  routes\ubase_16.rmp >nul

echo %1 >hybrdpth.xcf

rem COMMON SETUP PROCESSING

:common
if not exist geodata\english.xcu  if exist geodata\english.dat  copy geodata\english.dat  geodata\english.xcu  >nul
if not exist geodata\english2.xcu if exist geodata\english2.dat copy geodata\english2.dat geodata\english2.xcu >nul
if not exist geodata\german.xcu   if exist geodata\german.dat   copy geodata\german.dat   geodata\german.xcu   >nul
if not exist geodata\german2.xcu  if exist geodata\german2.dat  copy geodata\german2.dat  geodata\german2.xcu  >nul
if not exist geodata\french.xcu   if exist geodata\french.dat   copy geodata\french.dat   geodata\french.xcu   >nul
if not exist geodata\french2.xcu  if exist geodata\french2.dat  copy geodata\french2.dat  geodata\french2.xcu  >nul
if not exist geodata\spanish.xcu  if exist geodata\spanish.dat  copy geodata\spanish.dat  geodata\spanish.xcu  >nul
if not exist geodata\spanish2.xcu if exist geodata\spanish2.dat copy geodata\spanish2.dat geodata\spanish2.xcu >nul
if not exist geodata\obdata.xcu   copy geodata\obdata.dat   geodata\obdata.xcu   >nul

if not exist geodata\world.xcu    copy geodata\world.dat    geodata\world.xcu    >nul
if not exist missdat\saveinfo.dat copy manta.map            missdat\saveinfo.dat >nul

xcomutil ufoexe shp:cfg map:cfg wrt XcuSetup
if errorlevel 1 echo Error executing XCOMUTIL, XCUSETUP aborted
if errorlevel 1 goto finis
if exist maps\crypt01.map if not exist maps\crypt01.xcp  xcopy maps\crypt*.map  maps\crypt*.xcp  >nul
if exist maps\crypt01.xcu xcopy maps\crypt*.xcu maps\crypt*.map /y >nul

rem Check for the existence of Java

if exist havejava.xcf goto endjava
java -version >nul 2>nul
if errorlevel 1 goto endjava
echo Have Java >havejava.xcf
:endjava

rem Improved/Alternate Base

echo.
echo Do you want to use the improved starting base? (N)
sdump * getresp nNyY n
if errorlevel 3 goto impbase

echo.
echo Do you want to use the alternate starting base? (N)
sdump * getresp nNyY n
if errorlevel 3 goto altbase

xcomutil ufoexe bas:undo wrt
goto endimpbase

:altbase
xcomutil ufoexe bas:alt wrt
goto endimpbase

:impbase
xcomutil ufoexe bas wrt
:endimpbase

rem Improved Tanks

echo.
echo Do you want to use the improved tanks? (Y)
sdump * getresp yYnN y
if errorlevel 3 goto noimptanks
xcomutil ufoexe tnk wrt
goto endimptanks
:noimptanks
xcomutil ufoexe tnk:undo wrt
:endimptanks

rem Improved Weapons

if exist iwpnundo.xcu copy  iwpnundo.xcu geodata\obdata.dat >nul
if exist iwpnundo.xcu erase iwpnundo.xcu
echo.
echo Do you want to use the improved weapons? (Y)
sdump * getresp yYnN y
if errorlevel 3 goto endiwpn

xcomutil QueryInfo XcomVersion
if errorlevel 64 goto chktwpn
sdump xcomutil.tmp replace:iwpnxcom:54 xcomutil.cfg geodata\obdata.dat geodata\obdata.xcu >nul
goto chkiwpn
:chktwpn
sdump xcomutil.tmp replace:iwpntftd:54 xcomutil.cfg geodata\obdata.dat geodata\obdata.xcu >nul
:chkiwpn
if errorlevel 1 goto iwpnbad
goto iwpnok

:iwpnbad
echo.
echo These weapons have already been changed by some other program.
echo Do you want to override them and use the improved weapons? (N)
sdump * getresp yYnN n
if errorlevel 3 goto endiwpn
:iwpnok
copy  geodata\obdata.dat iwpnundo.xcu       >nul
copy  xcomutil.tmp       geodata\obdata.dat >nul
:endiwpn
if exist xcomutil.tmp erase xcomutil.tmp

rem New Laser Weapons

xcomutil QueryInfo XcomVersion
if errorlevel 64 goto endnlsr
set XCUGEO=ufoexe\geoscape.exe
if exist geoscape.exe set XCUGEO=geoscape.exe

sdump %XCUGEO% verify:NewLaser xcomutil.cfg >nul
if errorlevel 1 sdump %XCUGEO% verify:NLsrUndo xcomutil.cfg >nul
if errorlevel 1 goto nlsrbad

echo.
echo Do you want to use the new laser weapons? (N)
sdump * getresp yYnN n
if errorlevel 3 goto nlsrundo

sdump %XCUGEO% verify:NLsrUndo xcomutil.cfg >nul
if errorlevel 1 goto endnlsr

if not exist geodata\spanish.dat goto nonspan
if not exist geodata\spanish.xcl copy geodata\spanish.dat geodata\spanish.xcl >nul
sdump geodata\spanish.dat replace:NLsrTxSp xcomutil.cfg geodata\spanish.xcl geodata\spanish.xcu >nul
if errorlevel 1 goto nlsrbts
goto spantoo
:nlsrbts
copy  geodata\spanish.xcl geodata\spanish.dat >nul
erase geodata\spanish.xcl
goto nlsrbad

:nonspan
if not exist geodata\english.xcl if exist geodata\english.dat copy geodata\english.dat geodata\english.xcl >nul
if not exist geodata\german.xcl  if exist geodata\german.dat  copy geodata\german.dat  geodata\german.xcl  >nul
if not exist geodata\french.xcl  if exist geodata\french.dat  copy geodata\french.dat  geodata\french.xcl  >nul
sdump geodata\english.dat replace:NLsrText xcomutil.cfg geodata\english.xcl geodata\english.xcu >nul
if errorlevel 1 goto nlsrbtx
sdump geodata\german.dat  replace:NLsrTxDe xcomutil.cfg geodata\german.xcl  geodata\german.xcu  >nul
sdump geodata\french.dat  replace:NLsrTxFr xcomutil.cfg geodata\french.xcl  geodata\french.xcu  >nul

:spantoo
sdump %XCUGEO% patch:NewLaser xcomutil.cfg >nul
if exist game_1\product.dat sdump game_1\product.dat patch:NewLaser xcomutil.cfg >nul
if exist game_2\product.dat sdump game_2\product.dat patch:NewLaser xcomutil.cfg >nul
if exist game_3\product.dat sdump game_3\product.dat patch:NewLaser xcomutil.cfg >nul
if exist game_4\product.dat sdump game_4\product.dat patch:NewLaser xcomutil.cfg >nul
if exist game_5\product.dat sdump game_5\product.dat patch:NewLaser xcomutil.cfg >nul
if exist game_6\product.dat sdump game_6\product.dat patch:NewLaser xcomutil.cfg >nul
if exist game_7\product.dat sdump game_7\product.dat patch:NewLaser xcomutil.cfg >nul
if exist game_8\product.dat sdump game_8\product.dat patch:NewLaser xcomutil.cfg >nul
if exist game_9\product.dat sdump game_9\product.dat patch:NewLaser xcomutil.cfg >nul
if exist game_10\product.dat sdump game_10\product.dat patch:NewLaser xcomutil.cfg >nul
goto endnlsr

:nlsrundo
sdump %XCUGEO% verify:NewLaser xcomutil.cfg >nul
if errorlevel 1 goto endnlsr

if exist geodata\english.xcl copy  geodata\english.xcl geodata\english.dat >nul
if exist geodata\english.xcl erase geodata\english.xcl
if exist geodata\german.xcl  copy  geodata\german.xcl  geodata\german.dat >nul
if exist geodata\german.xcl  erase geodata\german.xcl
if exist geodata\french.xcl  copy  geodata\french.xcl  geodata\french.dat >nul
if exist geodata\french.xcl  erase geodata\french.xcl
if exist geodata\spanish.xcl copy  geodata\spanish.xcl geodata\spanish.dat >nul
if exist geodata\spanish.xcl erase geodata\spanish.xcl

sdump %XCUGEO% patch:NLsrUndo xcomutil.cfg >nul
if exist game_1\product.dat sdump game_1\product.dat patch:NLsrUndo xcomutil.cfg >nul
if exist game_2\product.dat sdump game_2\product.dat patch:NLsrUndo xcomutil.cfg >nul
if exist game_3\product.dat sdump game_3\product.dat patch:NLsrUndo xcomutil.cfg >nul
if exist game_4\product.dat sdump game_4\product.dat patch:NLsrUndo xcomutil.cfg >nul
if exist game_5\product.dat sdump game_5\product.dat patch:NLsrUndo xcomutil.cfg >nul
if exist game_6\product.dat sdump game_6\product.dat patch:NLsrUndo xcomutil.cfg >nul
if exist game_7\product.dat sdump game_7\product.dat patch:NLsrUndo xcomutil.cfg >nul
if exist game_8\product.dat sdump game_8\product.dat patch:NLsrUndo xcomutil.cfg >nul
if exist game_9\product.dat sdump game_9\product.dat patch:NLsrUndo xcomutil.cfg >nul
if exist game_10\product.dat sdump game_10\product.dat patch:NLsrUndo xcomutil.cfg >nul
goto endnlsr

:nlsrbtx
copy  geodata\english.xcl geodata\english.dat >nul
erase geodata\english.xcl
:nlsrbad
echo Weapons have already been changed by some other program.  You must
echo uninstall those changes if you want to use the new laser weapons.
:endnlsr

rem Research Help from Captured Aliens

echo.
echo Do you want to get research help from captured aliens? (N)
sdump * getresp yYnN n
if errorlevel 3 goto nocptv
xcomutil ufoexe rsh wrt
echo Research Help from Captured Aliens >rsrchhlp.xcf
goto endcptv

:nocptv
xcomutil ufoexe rsh:undo wrt
if exist rsrchhlp.xcf erase rsrchhlp.xcf >nul
:endcptv

rem Combat Messages

echo.
echo Do you want to see XcomUtil messages after combat? (N)
sdump * getresp yYnN n
if errorlevel 3 goto nonverb
echo Display Combat Messages >cmbtmsgs.xcf
:nonverb

rem AutoRename

echo.
echo Do you want stat strings added to the names of your troops? (Y)
sdump * getresp yYnN y
if errorlevel 3 goto norenam
echo Add Stat Strings to Troops >renamall.xcf

echo.
echo Do you want rank indicators added to the names of your troops? (Y)
sdump * getresp yYnN y
if errorlevel 3 goto norenam
echo Add Rank Indicators to Troops >renamrnk.xcf

echo.
echo Do you want their number of kills added to the names of your troops? (Y)
sdump * getresp yYnN y
if errorlevel 3 goto norenam
echo Add Kill Counts to Troops >renamkil.xcf
:norenam

rem AutoSort

echo.
echo Do you want your troops automatically sorted before combat? (Y)
sdump * getresp yYnN y
if errorlevel 3 goto nosort
echo Automatically Sort Combat Troops >autosort.xcf
:nosort

rem AutoEquip

echo.
echo Do you want to automatically re-equip your troops before combat? (Y)
sdump * getresp yYnN y
if errorlevel 3 goto noequip
echo Automatically Re-Euip Combat Troops >autoeqip.xcf

if not exist equiploc.xcu goto noequip
echo.
echo Do you want to reset your saved equipment? (N)
sdump * getresp nNyY n
if errorlevel 3 erase equiploc.xcu
:noequip

rem Mind Control

echo.
echo Do you want to eliminate mind control? (N)
sdump * getresp nNyY n
if errorlevel 3 goto nopsi
xcomutil ufoexe nmc:undo wrt

echo.
echo Do you want automatic screening for Psi ability? (N)
sdump * getresp nNyY n
if errorlevel 3 goto autoscrn
goto endpsi
:autoscrn
echo Automatic Screening for Psi >autoscrn.xcf
goto endpsi
:nopsi
xcomutil ufoexe nmc wrt
:endpsi

rem Daylight/Darkness

echo.
echo Do you want to fight all battles in daylight? (N)
sdump * getresp nNyY n
if errorlevel 3 goto nonight
echo.
echo Do you want to fight all battles in darkness? (N)
sdump * getresp nNyY n
if errorlevel 3 goto nolight
goto endlight
:nonight
echo All Battles in Daylight >daylight.xcf
goto endlight
:nolight
echo All Battles in Darkness >darkness.xcf
:endlight

rem New Farm and Desert

if exist mapaddon.xcf goto oldfarm
xcomutil QueryInfo XcomVersion
if errorlevel 64 goto oldfarm

if exist maps\backup\culta00.map goto newfarm

echo.
echo Saving Old Farm and Desert Terrain
md maps\backup    >nul
md routes\backup  >nul
md terrain\backup >nul

xcopy maps\culta*.map    maps\backup    >nul
xcopy maps\desert*.map   maps\backup    >nul
xcopy routes\culta*.rmp  routes\backup  >nul
xcopy routes\desert*.rmp routes\backup  >nul
xcopy terrain\cultivat.* terrain\backup >nul
xcopy terrain\barn.*     terrain\backup >nul
xcopy terrain\desert.*   terrain\backup >nul

:newfarm
echo.
echo Restoring Old Farm and Desert Terrain
xcopy maps\backup\cult*      maps    /y >nul
xcopy routes\backup\cult*    routes  /y >nul
xcopy terrain\backup\cult*   terrain /y >nul
xcopy terrain\backup\barn*   terrain /y >nul
xcopy maps\backup\desert*    maps    /y >nul
xcopy routes\backup\desert*  routes  /y >nul
xcopy terrain\backup\desert* terrain /y >nul

if not exist havejava.xcf goto oldfarm
echo.
echo Do you want use the new Farm and Desert terrains? (Y)
sdump * getresp yYnN y
if errorlevel 3 goto oldfarm

echo.
echo Creating New Farm and Desert Terrain
java -jar XcomUtTE.jar -quiet -mcd cultivat barn -map culta00 culta01 culta02 culta03 culta04 culta05 culta06 culta07 culta08 culta09 culta10 culta11 culta12 culta13 culta14 -mcd roads urbits urban frniture -map urban15 urban16 -write culta/cultivat
java -jar XcomUtTE.jar -quiet -mcd cultivat -map culta00 culta01 culta02 culta03 culta04 culta05 culta06 culta07 culta08 culta09 culta10 culta11 culta12 culta13 culta14 culta15 culta16 -mcd forest -map forest00 forest01 -write culta/cultivat
java -jar XcomUtTE.jar -quiet -mcd cultivat -map culta00 culta01 culta02 culta03 culta04 culta05 culta06 culta07 culta08 culta09 culta10 culta11 culta12 culta13 culta14 culta15 culta16 culta17 culta18 -change 39/20 40/21 43/2 44/11 45/7 85/2 -write culta/cultivat
xcopy terrain\blanks.* terrain\barn.* /y >nul

java -jar XcomUtTE.jar -quiet -mcd desert -map desert00 desert01 desert02 desert03 desert04 desert05 desert06 desert07 desert08 desert09 desert10 desert11 -mcd mars u_wall02 -map mars08 -write desert
java -jar XcomUtTE.jar -quiet -mcd desert -map desert00 desert12 desert02 desert03 desert04 desert05 desert06 desert07 desert08 desert09 desert10 desert11 desert01 -change 67/2 -write desert
:oldfarm

rem Random Terrain

echo.
echo Do you want combat terrain to be randomized? (N)
sdump * getresp nNyY n
if errorlevel 3 goto maprandom

echo.
echo Do you want to be prompted before every ship attack? (N)
sdump * getresp nNyY n
if errorlevel 3 goto mapprompt

echo.
echo Do you want the world map terrain to be randomized? (N)
sdump * getresp nNyY n
if errorlevel 3 goto rndworld

if not exist rndworld.xcf      goto endterrn
if not exist geodata\world.xcu goto endterrn
echo.
echo Do you want to restore the original world map? (N)
sdump * getresp nNyY n
if errorlevel 3 goto orgworld
goto endterrn

:orgworld
copy  geodata\world.xcu geodata\world.dat >nul
erase rndworld.xcf
goto endterrn

:rndworld
xcomutrt missdat rndworld
echo Randomized World Map Terrain >rndworld.xcf
goto endterrn

:mapprompt
echo Prompt Before Ship Attack >mpprompt.xcf
goto mapplace

:maprandom
echo Randomize Terrain >mprandom.xcf
goto mapplace
:endterrn

rem Random Terrain Placement (must follow Random Terrain)

echo.
echo Do you want XcomUtil to randomly place terrain on the battlefield? (N)
sdump * getresp nNyY n
if errorlevel 3 goto mapplace
goto noplace

:mapplace
echo Random Terrain Placement >rndplace.xcf
:noplace

rem Random Ships

if exist shipadon.xcf if exist xcomutil.rnd erase xcomutil.rnd
if exist shipadon.xcf goto norand
echo.
echo Do you want to randomize alien ship floorplans before each battle? (N)
sdump * getresp nNyY n
if errorlevel 3 goto randships
if exist xcomutil.rnd erase xcomutil.rnd
goto endrndsh

:randships
echo.
echo Do you want to keep copies of the generated files? (N)
sdump * getresp yYnN n
if errorlevel 3 goto endrndsh
echo Save Random Ship Files >saverand.xcf

:endrndsh
if exist xcomutil.rnd goto runrand
echo.
echo Do you want to randomize all of the alien ship floorplans now? (N)
sdump * getresp yYnN n
if errorlevel 3 goto norand

:runrand
echo.
echo Do you want the random ships to have random shapes? (Y)
sdump * getresp yYnN y
if errorlevel 3 goto semirand
echo Generate Random Shapes >rndshape.xcf

:semirand
if exist xcomutil.rnd goto norand
xcomutrt missdat allmaps
:norand

echo.
echo You should read XCOMUTIL.TXT for more information.
echo.

if not exist xcom4win.xcf goto farewell

echo To enable all of the features of XCOMUTIL, you must use the shortcut you
echo created to run the game or execute RUNXCOM.BAT from the command line.
goto finis

:farewell
echo To enable all of the features of XCOMUTIL, you must use RUNXCOM.BAT
echo to run the game.

:finis
if exist oldpatch.tmp erase oldpatch.tmp
if exist newpatch.tmp erase newpatch.tmp
echo.
